from pybricks.hubs import InventorHub
from pybricks.pupdevices import Motor, ColorSensor, UltrasonicSensor, ColorDistanceSensor
from pybricks.parameters import Port, Direction
from pybricks.tools import wait, StopWatch
from pybricks.geometry import Axis
hub = InventorHub(top_side=-Axis.X, front_side=Axis.Z)
# Initialize motors.
left = Motor(Port.C, Direction.COUNTERCLOCKWISE)
right = Motor(Port.D)
left.reset_angle(0)
right.reset_angle(0)
sensor1 = ColorSensor(Port.A)
sensor2 = ColorDistanceSensor(Port.F)

# Initialize hub and color sensor.
# You can also use the TechnicHub and/or the ColorDistanceSensor
# instead.
hub = InventorHub()
sensor = ColorSensor(Port.A)
kp = 28 #proportional gain 28 26
ki = 0.04 #integral gain 0.04 0.06
kd = 0.02 #derivative gain 0.02 0.02
ks = -0.00001
ks1 = 0.9991

roll_target = 0 #balance angle
BALANCE_MIN = 0
integral = 0
error = 0
derivative = 0
prev_error = 0
result = 0

start = 0
start_target = 0 #скорость
angle = 0
angleY = 0
angleY_corr = 0
steering = 5
angle_accel=0
motor_angle = 0
DT = 1.0
prev_time = 0
watch = StopWatch()
while not(hub.imu.ready()):
    pass
angleY_corr=hub.imu.rotation(Axis.Y)% 360

while True:

    prev_time = watch.time()

    # Get angular rate and estimated angle.
    rate = hub.imu.angular_velocity(Axis.Y)
    angle_accel += rate * DT / 1000
    angle_gyro = hub.imu.rotation(Axis.Y) % 360-angleY_corr
    angleY=angle_gyro*0.99+angle_accel*(1-0.99)
    
    #PID
    error = roll_target - angleY
    if abs(error) < BALANCE_MIN:
        error = 0
    integral = (integral + (error))*DT
    if DT == 0:
        DT = 1
    derivative = (error - prev_error)/DT
    prev_error = error

    motor_angle += (left.speed()+right.speed())/2*DT
    motor_angle *= ks1
    roll_target = motor_angle*ks

    duty = int((error*kp) + (integral*ki) + (derivative*kd))
    duty *= 7200 / hub.battery.voltage()
    left.dc(steering-duty)
    right.dc(-steering-duty)

    # Calculate steering.
    reflection1 = sensor1.reflection()*2.2222+1.1112#слева
    reflection2 = sensor2.reflection()*2.8571+4.2857#справа
    steering = round((reflection1 - reflection2)*0.8)

    DT = watch.time() - prev_time